package tech.riemann.bidding.component.impl;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;
import org.nutz.dao.Cnd;
import org.nutz.http.Header;
import org.nutz.http.Http;
import org.nutz.http.Response;
import org.nutz.lang.Strings;
import org.nutz.log.Logs;
import org.nutz.spring.boot.service.ExtService;

import lombok.RequiredArgsConstructor;
import tech.riemann.bidding.component.NoticeCollector;
import tech.riemann.bidding.entity.Notice;
import tech.riemann.bidding.entity.Notice.Channel;
import tech.riemann.bidding.repository.NoticeRepository;
import tech.riemann.bidding.repository.ScheduledLogRepository;

/**
 * 上海宝华国际渠道采集器
 */
// @Component
@Deprecated
@RequiredArgsConstructor
public class BaoSteelNoticeCollector extends NoticeCollector {

    private final NoticeRepository noticeRepository;
    private final ScheduledLogRepository scheduledLogRepository;

    @Override
    public NoticeRepository noticeRepository() {
        return noticeRepository;
    }

    @Override
    public ScheduledLogRepository scheduledLogRepository() {
        return scheduledLogRepository;
    }

    @Override
    public Channel channel() {
        return Channel.BAO_STEEL;
    }

    @Override
    public void collect() {
        // 没有cookie会报521,目前cookie值写死,后续需要研究是不是在请求首页的时候自动下发了cookie信息
        Response response = Http.get(channel().getUrl(),
                                     Header.create()
                                           .set("Host", "baosteelbidding.zbytb.com")
                                           .set("Referer", "https://baosteelbidding.zbytb.com/")
                                           .set("Cookie",
                                                "__jsluid_s=ac68c37cdc617959a40cef00227811e1; Du4_city=132%7Chttps%3A%2F%2Fbaosteelbidding.zbytb.com%2F; __jsl_clearance_s=1712113445.458|0|%2F%2BzxEoTkUCTMNxnyj9Nu2c1jodI%3D; Hm_lvt_47b9a4b804f6b4f81affae66cb8a57e9=1712023024,1712113449; Hm_lpvt_47b9a4b804f6b4f81affae66cb8a57e9=1712113475; Du4_vistor_st=3")
                                           .set("User-Agent",
                                                "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36 Edg/123.0.0.0"),
                                     5000);
        Logs.get().debugf("上海宝华国际渠道采集,网页访问状态码: %d", response.getStatus());
        if (response.isOK()) {
            // dom 解析
            Document document = Jsoup.parse(response.getContent());
            // .li_dot
            Elements elements = document.select("ul.li_dot li");
            Notice notice = Notice.builder().build();
            for (Element element : elements) {
                if (Strings.equals(element.attr("class"), "kws")) { // 第二行
                    notice.setPublishDate(date(element.text()));
                    if (noticeRepository.count(Cnd.where(Notice::getChannel, ExtService.EQ, notice.getChannel())
                                                  .and(Notice::getKey, ExtService.EQ, notice.getKey())) == 0) {
                        // 没有,插入数据,发送通知
                        noticeRepository.insert(notice);
                        sendMessage(notice);
                    }
                } else { // 第一行
                    Elements link = element.select("a");
                    String url = link.first().attr("href");
                    notice = Notice.builder()
                                   .channel(channel())
                                   .key(number(url) + "")
                                   .title(link.first().text())
                                   .content("")
                                   .url(url)
                                   .build();
                }
            }
        }

    }

}
