package tech.riemann.bidding.entity;

import java.time.LocalDateTime;

import org.nutz.dao.entity.annotation.Column;
import org.nutz.dao.entity.annotation.Comment;
import org.nutz.spring.boot.service.entity.IdEntity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonFormat.Shape;

import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.media.Schema.RequiredMode;
import lombok.AllArgsConstructor;
import lombok.Builder.Default;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import lombok.experimental.SuperBuilder;

@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = true)
public class IdBaseEntity extends IdEntity {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    @Schema(description = "创建时间", requiredMode = RequiredMode.NOT_REQUIRED)
    @Column("created_time")
    @Comment("创建时间")
    @Default
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "GMT+8", shape = Shape.STRING)
    protected LocalDateTime createdTime = LocalDateTime.now();

    @Schema(description = "最后更新时间", requiredMode = RequiredMode.NOT_REQUIRED)
    @Column("updated_time")
    @Comment("最后更新时间")
    @Default
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "GMT+8", shape = Shape.STRING)
    protected LocalDateTime updatedTime = LocalDateTime.now();

}
