package tech.riemann.bidding.entity;

import java.time.LocalDateTime;

import org.nutz.dao.entity.annotation.ColDefine;
import org.nutz.dao.entity.annotation.Column;
import org.nutz.dao.entity.annotation.Comment;
import org.nutz.dao.entity.annotation.Table;

import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.media.Schema.RequiredMode;
import lombok.AllArgsConstructor;
import lombok.Builder.Default;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import lombok.experimental.FieldNameConstants;
import lombok.experimental.SuperBuilder;
import tech.riemann.bidding.entity.Notice.Channel;

/**
 * 
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@FieldNameConstants
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@Table("t_scheduled_log")
@Comment("调度日志")
@Schema(name = "ScheduledLog", description = "调度日志")
public class ScheduledLog extends IdBaseEntity {

    private static final long serialVersionUID = 1L;

    @Schema(description = "公告渠道", requiredMode = RequiredMode.REQUIRED)
    @Column("l_channel")
    @Comment("公告渠道")
    @ColDefine(notNull = true, width = 50)
    Channel channel;

    @Schema(description = "开始时间", requiredMode = RequiredMode.REQUIRED)
    @Column("l_start")
    @Comment("开始时间")
    @Default
    LocalDateTime start = LocalDateTime.now();

    @Schema(description = "结束时间", requiredMode = RequiredMode.REQUIRED)
    @Column("l_end")
    @Comment("结束时间")
    @Default
    LocalDateTime end = LocalDateTime.now();

    @Schema(description = "线程id", requiredMode = RequiredMode.REQUIRED)
    @Column("l_thread_id")
    @Comment("线程id")
    long threadId;

}
